package concurrency.week10;

import java.util.LinkedList;

public class BufferImpl<T> implements Buffer<T> {

	protected LinkedList<T> buf = new LinkedList<T>();

	public BufferImpl() {
	}

	public synchronized void put(T o) throws InterruptedException {
		buf.addLast(o);
		notifyAll();
	}

	public synchronized T get() throws InterruptedException {
		while (buf.isEmpty()) {
			wait();
		}
		return buf.removeFirst();
	}

}
