package concurrency.week10;

import java.util.LinkedList;

class Filter extends Thread {

	private Pipe<Integer> inpipe, outpipe;

	private int index;

	private LinkedList<Integer> receivedValues = new LinkedList<Integer>();
	private LinkedList<Integer> sentValues = new LinkedList<Integer>();

	public Filter(Pipe<Integer> inpipe, Pipe<Integer> outpipe, int index) {
		this.inpipe = inpipe;
		this.outpipe = outpipe;
		this.index = index;
	}

	public void run() {
		int receivedValue, filterValue;

		try {
			filterValue = inpipe.get();
			System.out.println("Filter [" + index + "]: first received "
					+ filterValue);
			receivedValues.add(filterValue);
			if (filterValue == Primes.EOS && outpipe != null) {
				outpipe.put(filterValue);
				return;
			}

			while (true) {
				receivedValue = inpipe.get();
				sleep(200);
				if (receivedValue == Primes.EOS) {
					System.out.println("Filter [" + index
							+ "] (first value was " + filterValue
							+ ") : received EOS, finally received "
							+ receivedValues + " and sent out " + sentValues);
					if (outpipe != null) {
						outpipe.put(receivedValue);
					}
					break;
				} else {
					receivedValues.add(receivedValue);
					if (receivedValue % filterValue != 0 && outpipe != null) {
						System.out.println("Filter [" + index
								+ "] (first value was " + filterValue
								+ ") : received and is processing "
								+ receivedValue);
						sentValues.add(receivedValue);
						outpipe.put(receivedValue);
					}
				}

			}
		} catch (InterruptedException e) {
		}
	}
}